{{  VDIP1 First try.   FIFO mode.
This code is only for test the speed of the VDIP working in Spin, it's working with my pen drive, the way that I use
to read the messages from the VDIP is NOT suitable for other drives (it is not academic, and is incorrect), also there
are not separate objects for  some tasks, so the code is longest that it could be.

I test the speed, only in one portion of the code, and using 'cnt', that portion was erased, it is not included here.
}}
CON
    _clkmode = xtal1 + pll16x                           
    _xinfreq = 5_000_000

        RXF     = 8     ' Propeller pins
        TXE     = 9
        VWR     = 11
        VRD     = 10
        RST     = 27
                        ' Data pins are P0 to P7

VAR
        long          dato[1154]   ' To store data that VDIP read from USB flash disk.
        long          temp        
        long          x
        long          y
        long          su
        long          sd
        long          speed
                
OBJ
  tv          : "tv_text"
        
PUB start

   tv.start(12)
   tv.str(string("Vinculum Test...... ",13))

outa[RST]~~
dira[RST]~~   ' Output

outa[RXF]~
outa[TXE]~
dira[RXF]~     ' Input
dira[TXE]~     ' Input

outa[VWR]~
outa[VRD]~~
dira[VWR]~~   ' Output
dira[VRD]~~   ' Output

outa[7..0]~
dira[7..0]~

x:=0

 !outa[RST]       '                                      
 !outa[RST]       '                                      
 tv.str(string("Reset Vinculum.... ",13))

'********************************************************************************
' READS     'Version and Device Detected P2' 
'********************************************************************************
   temp := INA[RXF]
   repeat while temp <> 0
    temp := INA[RXF]
 tv.str(string("Reading.... ",13))

    repeat 44
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1

    x:=0
    repeat 44                   ' Show in TV  
     y := dato[x]       
     if y <> 0
       tv.out(y)       
     x := x + 1                            ' At this point we get the Firmware version and the device state.
'********************************************************************************



'********************************************************************************
' READS    ' No Upgrade nd D:\>" 
'********************************************************************************
    temp := INA[RXF]
    repeat while temp <> 0
     temp := INA[RXF]

x:=0
dira[7..0]~
    temp := INA[RXF]
    repeat while temp <> 0
     temp := INA[RXF]

    repeat 16
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1
      
    x:=0
    repeat 16                      ' Show in TV
     y := dato[x]       
     tv.out(y)       
     x := x + 1                            ' At this point we get the Firmware version and the device state.
'********************************************************************************

waitcnt(clkfreq + cnt)

'********************************************************************************
' SENDING  A COMMAND   (change to 'short' mode)
'********************************************************************************

  dira[7..0]~~  'Change to outputs.

   temp := INA[TXE]
   repeat while temp <> 0
    temp := INA[TXE]

   outa[7..0] := $73        'command change to shortened mode 
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $63        'command change to shortened mode 
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $73        'command change to shortened mode 
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $0D        'command change to shortened mode 
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

'********************************************************************************
'********************************************************************************

 tv.str(string(13,"Short command mode prompt.... "))

'********************************************************************************
' READS  'Bad Command' 
'********************************************************************************
x:=0
dira[7..0]~    ' Change to inputs.

    repeat 2
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1
'      tv.dec(x)
      
    tv.out($0D)
    x:=0
    repeat 2                      ' Show in TV
     y := dato[x]       
     tv.out(y)       
     x := x + 1


'********************************************************************************

waitcnt(clkfreq + cnt)

'********************************************************************************
' SENDING  A COMMAND    "Directory'
'********************************************************************************

  dira[7..0]~~  'Change to outputs.

   temp := INA[TXE]
   repeat while temp <> 0
    temp := INA[TXE]


   outa[7..0] := $01         
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $0D         
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

'********************************************************************************
'********************************************************************************

 tv.str(string(13,"Directory of the disk.... "))

'********************************************************************************
' READS  'Bad Command' 
'********************************************************************************
x:=0
dira[7..0]~    ' Change to inputs.

    repeat 18               ' This for my example only 
      temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1
'      tv.dec(x)
      
    tv.out($0D)
    x:=0
    repeat 18                    ' Show in TV
     y := dato[x]       
     tv.out(y)       
     x := x + 1
'********************************************************************************

waitcnt(clkfreq + cnt)


'********************************************************************************
' SENDING  A COMMAND    Open file for read
'********************************************************************************

  dira[7..0]~~  'Change to outputs.

   temp := INA[TXE]
   repeat while temp <> 0
    temp := INA[TXE]


   outa[7..0] := $0E        
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $20         
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := 66        
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := 46        
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := 98        
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := 116       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := 120       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $0D       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

'********************************************************************************
'********************************************************************************

 tv.str(string(13,"Open File.... "))
'********************************************************************************
' READS  'Bad Command' 
'********************************************************************************
x:=0
dira[7..0]~    ' Change to inputs.

    repeat  5
     temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1
      
    tv.out($0D)
    x:=0
    repeat 5                        ' Show in TV
      y := dato[x]       
'     if y <> 0
      tv.out(y)       
     x := x + 1
'********************************************************************************

waitcnt(clkfreq + cnt)

'********************************************************************************
' SENDING  A COMMAND    Read data from the file 1152 bytes + 2 ?? I don't know why read two more
'********************************************************************************

  dira[7..0]~~  'Change to outputs.

   temp := INA[TXE]
   repeat while temp <> 0
    temp := INA[TXE]

   outa[7..0] := $0B         
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $20        
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $00       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $00       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $04       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $80       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

   outa[7..0] := $0D       
   !outa[VWR]       '                                      
   !outa[VWR]       '                                                      

'********************************************************************************
'********************************************************************************

 tv.str(string(13,"Data read... ",13))

'********************************************************************************
' READS  'Bad Command' 
'********************************************************************************
x:=0
dira[7..0]~    ' Change to inputs.


    repeat  1154
     temp := INA[RXF]
      repeat while temp <> 0
       temp := INA[RXF]
 
      !outa[VRD]       '                                      
      dato[x] := INA[7..0]                'To read data sent by the  VDIP
      !outa[VRD]       '                                                      
      x := x + 1

    tv.out($0D)
    x:=0
    repeat 1154                 ' Show in TV
     y := dato[x]       
     if y <> 0
      tv.out(y)       
'     tv.str(string("-"))
'     tv.out(y)       
     x := x + 1
'********************************************************************************

 tv.str(string(13,"Ready... "))

repeat
       